######################################################################
# Automatically generated by qmake (2.01a) Mon Dec 27 12:07:07 2010
######################################################################

TEMPLATE 	= 	app

VERSION         =       1.0.12

TARGET 		=       cdm

CONFIG          += 	qt thread opengl warn_off release 

DEPENDPATH 	+= .

QT      	+= 	core concurrent widgets sql svg opengl printsupport datavisualization

DEFINES 	+=      CDMVERSION=\\\"$$VERSION\\\" 
unix::DEFINES   +=      OS=LINUX
win32::DEFINES  +=      OS=WIN32

CONFIG(fftw) {
DEFINES 	+=      USE_FFTW
}
CONFIG(hdf5) {
DEFINES 	+=      USE_HDF5
}

#DEFINES 	+= 	QT_NO_DEBUG_OUTPUT

MOC_DIR         = moc
RCC_DIR         = resources

!debug_and_release {
    OBJECTS_DIR       = obj
}

QMAKE_CXXFLAGS_RELEASE  -= -O2 

QMAKE_CXXFLAGS 	+= -O3 -g

QMAKE_CC        =       gfortran

QMAKE_CFLAGS    += -g -Wall -fcray-pointer -w  -mcmodel=large -fopenmp

QMAKE_LFLAGS    = -mcmodel=large

HEADERS 	+= 	cdmMain.h \
			cdmOptions.h \
			cdmOptionsWidget.h \
			cdmOptionsWindow.h \
			cdmBeamConfigDialog.h \
			cdmObjectConfigDialog.h \
			cdmEpsilonConfigDialog.h \
			cdmRunWidget.h \
			cdmRun.h \
                        cdmPlot.h \
			QsLog.h \
			QsDebugOutput.h \
			QsLogDest.h \
                        Assistant.h

SOURCES		+= 	cdmMain.cpp \
			cdmOptions.cpp \
			cdmOptionsWidget.cpp \
			cdmOptionsWindow.cpp \
			cdmBeamConfigDialog.cpp \
			cdmObjectConfigDialog.cpp \
			cdmEpsilonConfigDialog.cpp \
			cdmRunWidget.cpp \
			cdmRun.cpp \
			cdmPlot.cpp \
			QsLog.cpp \
			QsDebugOutput.cpp \
			QsLogDest.cpp \
                        Assistant.cpp

CDMLIB_LIB_PATH  =  	../cdmlib/lib

CDMLIB_INC_PATH  =      ../cdmlib

QWT_LIB_PATH     =  	../qwt-6.2.0/lib

QWT_INC_PATH     =      ../qwt-6.2.0/src

INCLUDEPATH 	+=	$$CDMLIB_INC_PATH $$QWT_INC_PATH

win32::LIBS 	+= -L$$CDMLIB_LIB_PATH -lcdmlib \
                   -L$$QWT_LIB_PATH -lqwt \
                   -lglu32 -lz -lopengl32 -lgfortran

unix:LIBS       += -Wl,-rpath,$$CDMLIB_LIB_PATH \
                   -L$$CDMLIB_LIB_PATH -lcdmlib \
                   -Wl,-rpath,$$QWT_LIB_PATH \
                   -L$$QWT_LIB_PATH -lqwt \
                   -Wl,-Bdynamic \
                   -lGLU -lgfortran 

CONFIG(fftw) {
unix:LIBS            += -lfftw3_omp -lfftw3 -lm
}

CONFIG(hdf5) {
# sur centos, fedora, etc...
  exists( /usr/lib64/gfortran/modules ) {
  unix:LIBS            += -I/usr/lib64/gfortran/modules -I/usr/include -L/usr/lib64 -lhdf5hl_fortran -lhdf5_hl -lhdf5_fortran -lhdf5
  }
# sur ubuntu
  exists( /usr/include/hdf5/serial ) {
  unix:LIBS            += -I/usr/include/hdf5/serial -I/usr/include -L/usr/lib/x86_64-linux-gnu/hdf5/serial -lhdf5hl_fortran -lhdf5_hl -lhdf5_fortran -lhdf5
  }
}


# make install
documentation.extra = ./make_doc.run
documentation.path = /usr/local/bin/doc
documentation.files = doc/*

target.path = $$PWD/../bin

options.path = $$PWD/../bin
options.files = options.db3

data.path = $$PWD/../bin
data.files = $$PWD/../data/*

INSTALLS += target options data

QMAKE_DISTCLEAN += bin/*
