      subroutine multilayerbornscaref(xs,ys,zs,aretecube,k0,w0,E0,ss,pp
     $     ,theta,phi,xgaus,ygaus,zgaus,beam,epsilon,polarisa,ndipole,nx
     $     ,ny,nz ,nxm,nym,nzm ,nmax,nfft2d,imagex,imagey,imagez,FF0
     $     ,FFloc,FF ,plan2f,plan2b ,nstop,infostr)
      
      implicit none

      integer i,j,k,l,kk,nfft2d,ii,jj,ll,nstop,kkm,jjm,tabfft(nfft2d
     $     *nfft2d),comparaison
      double complex imagex(nfft2d*nfft2d),imagey(nfft2d*nfft2d)
     $     ,imagez(nfft2d*nfft2d),ctmp,E0,Uincx,Uincy,Uincz
      double precision xmax,xmin,ymax,ymin,x,y,z,xgaus,ygaus,zgaus,Emod
      character(64) infostr
      character(64) beam
c     input data
      integer nx,ny,nz,nx2,ny2,nxm,nym,nzm,nmax,ndipole,indice,nsens,nxl
     $     ,nyl,nloin
      double precision xs(nmax),ys(nmax),zs(nmax),k0,w0,ss,pp,theta,phi
     $     ,aretecube,kz,kx,ky,deltakx,deltaky,fac,fac2,pi,kzc,constpola
     $     ,r,xx0,yy0,zz0,tol
      double complex epsilon(nmax,3,3),polarisa(nmax,3,3),FFloc(3*nmax)
     $     ,FF(3*nmax),FF0(3*nmax),icomp,Em(3),Eloc(3),epsani(3,3),Ex,Ey
     $     ,Ez
      integer*8 plan2f,plan2b,plan4b,plan4f
c     output data
      integer FFTW_BACKWARD,FFTW_FORWARD,FFTW_ESTIMATE

      double complex , dimension (:), allocatable :: FFTTENSOR
     $     ,polarisation,champ
      double complex , dimension (:,:), allocatable :: champtx
      double precision Emodmax,tolc

      FFTW_BACKWARD=+1
      FFTW_FORWARD=-1
      FFTW_ESTIMATE=64
      pi=dacos(-1.d0)
      icomp=(0.d0,1.d0)
      fac=1.d0/dble(nfft2d*nfft2d)
      constpola=aretecube*aretecube*aretecube/4.d0/pi

c     verifie taille fft
      if (nfft2d.le.nx) then
         nstop=1
         infostr='nfft2d too small'
      endif
      if (nfft2d.le.ny) then
         nstop=1
         infostr='nfft2d too small'
      endif
      
      deltakx=2.d0*pi/(dble(nfft2d)*aretecube)
      deltaky=2.d0*pi/(dble(nfft2d)*aretecube)
  
      if (deltakx.ge.k0/2.d0) then
         nstop=1
         infostr='nfft2d too small'
      endif
      if (deltaky.ge.k0/2.d0) then
         nstop=1
         infostr='nfft2d too small'
      endif
      if (nstop.eq.1) return

c     calcul de la fonction de Green scalaire
      nxl=nfft2d
      nyl=nfft2d      
      nx2=2*nfft2d
      ny2=2*nfft2d      
      fac2=1.d0/dble(nx2*ny2)
c     definir taille tableau double
      allocate(FFTTENSOR(1:nx2*ny2))
      allocate(polarisation(1:nx2*ny2))
      allocate(champ(1:nx2*ny2))
      allocate(champtx(1:nfft2d*nfft2d,1:nzm))
c     definir plan FFT double
#ifdef USE_FFTW
      call dfftw_plan_dft_2d(plan4b, nx2,ny2,champ,champ,FFTW_BACKWARD
     $     ,FFTW_ESTIMATE)
      call dfftw_plan_dft_2d(plan4f,nx2,ny2,champ,champ,FFTW_FORWARD
     $     ,FFTW_ESTIMATE)
#endif
c     calcul fonction de Green
      
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(ii,jj,indice,i,j)
!$OMP& PRIVATE(xx0,yy0,zz0,r)
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)        
      do jj=1,ny2
         do ii=1,nx2
            indice=ii+nx2*(jj-1)
            if (ii.eq.nxl+1.or.jj.eq.nyl+1) then
               FFTTENSOR(indice)=0.d0
            else
               if (ii.gt.nxl) then
                  i=(ii-1)-nx2
               else
                  i=ii-1
               endif
               if (jj.gt.nyl) then
                  j=(jj-1)-ny2
               else
                  j=jj-1
               endif
               xx0=dble(i)*aretecube
               yy0=dble(j)*aretecube
               zz0=aretecube

               r=dsqrt(xx0*xx0+yy0*yy0+zz0*zz0)
               if (r.eq.0.d0) r=1.d300
               FFTTENSOR(indice)=k0*k0*cdexp(icomp*k0*r)/r
             
            endif
         enddo
      enddo
!$OMP ENDDO 
!$OMP END PARALLEL
      
      write(*,*) 'End computation of the scalar Green function'
c     compute the FFT of the Green function
  

#ifdef USE_FFTW
      call dfftw_execute_dft(plan4b,FFTTENSOR,FFTTENSOR)    
#else
      call fftsingletonz2d(FFTTENSOR,NX2,NY2,FFTW_BACKWARD)
#endif
      
      write(*,*) 'End FFT scalar Green function'

      
      xmax=-1.d300
      xmin=1.d300
      ymax=-1.d300
      ymin=1.d300

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i)
!$OMP DO SCHEDULE(STATIC) REDUCTION(max:xmax,ymax)
!$OMP& REDUCTION(min:xmin,ymin)     
      do i=1,ndipole
         xmax=max(xmax,xs(i))
         xmin=min(xmin,xs(i))
         ymax=max(ymax,ys(i))
         ymin=min(ymin,ys(i))     
      enddo
!$OMP ENDDO 
!$OMP END PARALLEL
              
      kkm=(nfft2d-nx)/2
      jjm=(nfft2d-ny)/2

      Emodmax=0.d0
      if (beam(1:11).eq.'gwavelinear'.or.beam(1:14).eq
     $     .'gfftwavelinear') then
         do j=1,nfft2d
            do k=1,nfft2d       
               x=xmin+dble(k-kkm-1)*aretecube
               y=ymin+dble(j-jjm-1)*aretecube
               call gaussianparalinear(x,y,z,xgaus,ygaus,zgaus,theta,
     $              phi,w0,k0,ss,pp,E0,Ex,Ey,Ez,nstop,infostr)
               Emodmax=max(dreal(Ex*dconjg(Ex)+Ey*dconjg(Ey)+Ez
     $              *dconjg(Ez)),Emodmax)
            enddo
         enddo
      endif
      if (beam(1:13).eq.'gwavecircular'.or.beam(1:16).eq
     $     .'gfftwavecircular') then
         do j=1,nfft2d
            do k=1,nfft2d       
               x=xmin+dble(k-kkm-1)*aretecube
               y=ymin+dble(j-jjm-1)*aretecube
               call gaussianparalinear(x,y,z,xgaus,ygaus,zgaus,theta,
     $              phi,w0,k0,ss,pp,E0,Ex,Ey,Ez,nstop,infostr)
               Emodmax=max(dreal(Ex*dconjg(Ex)+Ey*dconjg(Ey)+Ez
     $              *dconjg(Ez)),Emodmax)
            enddo
         enddo
      endif
      
      write(*,*) 'int',k0/deltakx,theta*180.d0/pi
      write(*,*) 'beam',beam
c     calcul orientation du vecteur polarisation
      x=0.d0
      y=0.d0
      z=0.d0
      if (beam(1:11).eq.'pwavelinear') then
         call ondeplane(x,y,z,k0,E0,ss,pp,theta,phi,Uincx,Uincy,Uincz
     $        ,nstop,infostr)
      elseif (beam(1:13).eq.'pwavecircular') then
         call ondecirce(x,y,z,k0,E0,ss,theta,phi ,Uincx,Uincy,Uincz)
      elseif (beam(1:15).eq.'gparawavelinear') then
         call gaussianparalinear(xgaus,ygaus,zgaus,xgaus,ygaus,zgaus
     $        ,theta,phi,w0,k0,ss,pp,E0,Uincx,Uincy,Uincz ,nstop
     $        ,infostr)
      elseif (beam(1:17).eq.'gparawavecircular') then
         call gaussianparacirc(xgaus,ygaus,zgaus,xgaus,ygaus,zgaus
     $        ,theta,phi,w0,k0,ss,E0,Uincx,Uincy,Uincz ,nstop,infostr)
      elseif (beam(1:11).eq.'gwavelinear'.or.beam(1:14).eq
     $        .'gfftwavelinear') then
         nloin=0
         tol=1.d-3
         call gaussianchamp(xgaus,ygaus,zgaus,xgaus,ygaus,zgaus ,theta
     $        ,phi,w0,k0,ss,pp,E0,Uincx,Uincy,Uincz,tol ,nloin,nstop
     $        ,infostr)
      elseif  (beam(1:13).eq.'gwavecircular'.or.beam(1:16).eq
     $        .'gfftwavecircular') then
         nloin=0
         tol=1.d-3
         call gaussianchampcirc(xgaus,ygaus,zgaus,xgaus,ygaus ,zgaus
     $        ,theta,phi,w0,k0,ss,E0,Uincx,Uincy,Uincz ,tol,nloin,nstop
     $        ,infostr)
      else
         write(*,*) 'Beam not implemented for this approximation'
         nstop=1
         infostr='Beam not implemented for this approximation'
         return 
      endif
c     normalise le vecteur unitaire
      Emod=dsqrt(cdabs(Uincx)**2.d0+cdabs(Uincy)**2.d0+cdabs(Uincz)
     $     **2.d0)
      Uincx=Uincx/Emod
      Uincy=Uincy/Emod
      Uincz=Uincz/Emod
      write(*,*) 'coucou',Uincx,Uincy,Uincz
      l=1
      z=zs(1)
c     intialise le premier z au champ incident
      do j=1,nfft2d
         do k=1,nfft2d       
            ii=k+(j-1)*nfft2d
            x=xmin+dble(k-kkm-1)*aretecube
            y=ymin+dble(j-jjm-1)*aretecube
            if (comparaison(x,y,z,xs(l),ys(l),z
     $           ,aretecube).eq.1.and.l.le.ndipole)  then
               tabfft(ii)=l
               kk=3*(l-1)
               Imagex(ii)=uincx*FF0(kk+1)+uincy*FF0(kk+2)+uincz*FF0(kk
     $              +3)
               FFloc(kk+1)=FF0(kk+1)
               FFloc(kk+2)=FF0(kk+2)
               FFloc(kk+3)=FF0(kk+3)
               l=l+1
            else
               tabfft(ii)=0
               if (beam(1:11).eq.'pwavelinear') then
                  call ondeplane(x,y,z,k0,E0,ss,pp,theta,phi ,Ex,Ey,Ez
     $                 ,nstop,infostr)
               elseif (beam(1:13).eq.'pwavecircular') then
                  call ondecirce(x,y,z,k0,E0,ss,theta,phi,Ex,Ey,Ez)
               elseif (beam(1:15).eq.'gparawavelinear') then
                  call gaussianparalinear(x,y,z,xgaus,ygaus,zgaus,theta
     $                 ,phi,w0,k0,ss,pp,E0,Ex,Ey,Ez,nstop,infostr)
               elseif (beam(1:17).eq.'gparawavecircular') then
                  call gaussianparacirc(x,y,z,xgaus,ygaus,zgaus ,theta
     $                 ,phi,w0,k0,ss,E0,Ex,Ey,Ez,nstop,infostr)
               elseif (beam(1:11).eq.'gwavelinear'.or.beam(1:14).eq
     $                 .'gfftwavelinear') then
                  nloin=0
                  tol=1.d-3
		  call gaussianparalinear(x,y,z,xgaus,ygaus,zgaus,theta
     $                 ,phi,w0,k0,ss,pp,E0,Ex,Ey,Ez,nstop
     $                 ,infostr)
                  Emod=dreal(Ex*dconjg(Ex)+Ey*dconjg(Ey)+Ez*dconjg(Ez))
                  tolc=dsqrt(Emod/Emodmax)*10.d0	
                  if (tolc.ge.tol) then
                     call gaussianchamp(x,y,z,xgaus,ygaus,zgaus ,theta
     $                    ,phi,w0,k0,ss,pp,E0,Ex,Ey,Ez,tol ,nloin ,nstop
     $                    ,infostr)               
                  endif
                  
               elseif  (beam(1:13).eq.'gwavecircular'.or.beam(1:16).eq
     $                 .'gfftwavecircular') then
                  nloin=0
                  tol=1.d-3
                  call gaussianparacirc(x,y,z,xgaus,ygaus,zgaus,theta
     $                 ,phi,w0,k0,ss,E0,Ex,Ey,Ez,nstop ,infostr)
                  Emod=dreal(Ex*dconjg(Ex)+Ey*dconjg(Ey)+Ez*dconjg(Ez))
                  tolc=dsqrt(Emod/Emodmax)*10.d0
                  if (tolc.ge.tol) then
                     call gaussianchampcirc(x,y,z,xgaus,ygaus ,zgaus
     $                    ,theta,phi,w0,k0,ss,E0,Ex,Ey,Ez ,tol,nloin
     $                    ,nstop,infostr)   
                  endif
               endif
               Imagex(ii)=uincx*Ex+uincy*Ey+uincz*Ez
            endif

         enddo
      enddo
c      do j=1,nfft2d
c         do k=1,nfft2d     
c            ii=k+(j-1)*nfft2d
c            write(100,*) cdabs(Imagex(ii))
c         enddo
c      enddo
c     commence boucle sur les z
c      write(*,*) 'coucou1'
      do k=2,nz
c      write(*,*) 'coucouk',k


c     caclul de la polarisation
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)         
         do j=1,ny2
            do i=1,nx2
               ii=i+(j-1)*nx2
               polarisation(ii)=0.d0
            enddo
         enddo
!$OMP ENDDO 
!$OMP END PARALLEL

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii,jj,l) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2) 
         do j=1,nyl
            do i=1,nxl
               ii=i+(j-1)*nx2
               jj=i+(j-1)*nxl
               if (tabfft(jj).ne.0)  then
                  l=nx*ny*(k-1)+tabfft(jj)
                  polarisation(ii)=Imagex(jj)*polarisa(l,1,1)           
               endif
            enddo
         enddo
!$OMP ENDDO 
!$OMP END PARALLEL         

c     fait la FFT de la polarisation sur le plan
#ifdef USE_FFTW
         call dfftw_execute_dft(plan4b,polarisation,polarisation)
#else
         call fftsingletonz2d(polarisation,nx2,ny2,FFTW_BACKWARD)
#endif       
c         write(*,*) 'coucou6'
c     fait le produit des deux FFT
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)          
         do j=1,ny2
            do i=1,nx2
               ii=i+(j-1)*nx2
               champ(ii)=polarisation(ii)*FFTTENSOR(ii)
            enddo
         enddo
!$OMP ENDDO 
!$OMP END PARALLEL         

c     fait la FFT inverse pour avoir le champ diffracte
#ifdef USE_FFTW
         call dfftw_execute_dft(plan4f,champ,champ)
#else
         call fftsingletonz2d(champ,nx2,ny2,FFTW_FORWARD)
#endif 
c         do j=1,ny2
c            do i=1,nx2
c               ii=i+(j-1)*nx2
c               write(102,*) cdabs(champ(ii))
c            enddo
c         enddo
c         write(*,*) 'coucou8'         
c     propage le champ d une couche         
c     FFT à deux dimensions
c         do j=1,nyl
c            do i=1,nxl
c               ii=i+(j-1)*nxl
c               write(110,*) cdabs(Imagex(ii))
c            enddo
c         enddo

#ifdef USE_FFTW
         call dfftw_execute_dft(plan2b,Imagex,Imagex)
#else
         call fftsingletonz2d(Imagex,nfft2d,nfft2d,FFTW_BACKWARD)
#endif
c         write(*,*) 'coucou9'
c         do j=1,nfft2d
c            do i=1,nfft2d     
c               ii=i+(j-1)*nfft2d
c               write(103,*) cdabs(Imagex(ii))
c            enddo
c         enddo
         
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,indice,ii,jj,kx,ky,kz,ctmp)
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)       
         do j=1,nfft2d
            do i=1,nfft2d
               indice=i+nfft2d*(j-1)
               if (i.gt.nfft2d/2) then
                  ii=i-nfft2d-1
               else
                  ii=i-1
               endif
               if (j.gt.nfft2d/2) then
                  jj=j-nfft2d-1
               else
                  jj=j-1
               endif              
               kx=deltakx*dble(ii)
               ky=deltaky*dble(jj)
               kz=k0*k0-kx*kx-ky*ky
               if (kz.ge.0.d0) then
                  kz=dsqrt(kz)
                  ctmp=cdexp(icomp*kz*aretecube)
                  Imagex(indice)=Imagex(indice)*ctmp
               else
                  Imagex(indice)=0.d0
               endif

            enddo
         enddo
!$OMP ENDDO 
!$OMP END PARALLEL

#ifdef USE_FFTW
         call dfftw_execute_dft(plan2f,Imagex,Imagex)
#else
         call fftsingletonz2d(Imagex,nfft2d,nfft2d,FFTW_FORWARD)
#endif
c         do j=1,nfft2d
c            do i=1,nfft2d     
c               ii=i+(j-1)*nfft2d
c               write(104,*) cdabs(Imagex(ii))
c            enddo
c         enddo
         
c     somme les deux champs.
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii,indice,kk,ll) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2) 
         do j=1,nyl
            do i=1,nxl
               indice=i+(j-1)*nxl
               ll=i+(j-1)*nx2
               Imagex(indice)=Imagex(indice)*fac+champ(ll)*fac2
               champtx(indice,k)=Imagex(indice)
                if (tabfft(indice).ne.0)  then                 
                  ii=nx*ny*(k-1)+tabfft(indice)
                  kk=3*(ii-1)
                  FFloc(kk+1)=Imagex(indice)*uincx
                  FFloc(kk+2)=Imagex(indice)*uincy
                  FFloc(kk+3)=Imagex(indice)*uincz               
               endif
            enddo
         enddo 
!$OMP ENDDO 
!$OMP END PARALLEL
         
      enddo

c     TRANSMISSION

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)         
      do j=1,ny2
         do i=1,nx2
            ii=i+(j-1)*nx2
            polarisation(ii)=0.d0
         enddo
      enddo
!$OMP ENDDO 
!$OMP END PARALLEL

      k=nz
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii,jj,l) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2) 
      do j=1,nyl
         do i=1,nxl
            ii=i+(j-1)*nx2
            jj=i+(j-1)*nxl
            if (tabfft(jj).ne.0)  then
               l=nx*ny*(k-1)+tabfft(jj)
               polarisation(ii)=champtx(jj,k)*polarisa(l,1,1)           
            endif
         enddo
      enddo
!$OMP ENDDO 
!$OMP END PARALLEL         

c     fait la FFT de la polarisation sur le plan
#ifdef USE_FFTW
      call dfftw_execute_dft(plan4b,polarisation,polarisation)
#else
      call fftsingletonz2d(polarisation,nx2,ny2,FFTW_BACKWARD)
#endif       
c     write(*,*) 'coucou6'
c     fait le produit des deux FFT
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)          
      do j=1,ny2
         do i=1,nx2
            ii=i+(j-1)*nx2
            champ(ii)=polarisation(ii)*FFTTENSOR(ii)
         enddo
      enddo
!$OMP ENDDO 
!$OMP END PARALLEL         

c     fait la FFT inverse pour avoir le champ diffracte
#ifdef USE_FFTW
      call dfftw_execute_dft(plan4f,champ,champ)
#else
      call fftsingletonz2d(champ,nx2,ny2,FFTW_FORWARD)
#endif         

c     somme les deux champs.
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii,ll) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)         
      do j=1,nyl
         do i=1,nxl
            ii=i+(j-1)*nxl
            ll=i+(j-1)*nx2
            Imagex(ii)=champ(ll)*fac2
         enddo
      enddo 
!$OMP ENDDO 
!$OMP END PARALLEL    
      k=nz-1
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,indice,ii,kk) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2) 
      do j=1,nfft2d
         do i=1,nfft2d         
            indice=i+(j-1)*nfft2d
            if (tabfft(indice).ne.0)  then               
               ii=nx*ny*(k-1)+tabfft(indice)
               kk=3*(ii-1)
               FFloc(kk+1)=FFloc(kk+1)+Imagex(indice)*uincx
               FFloc(kk+2)=FFloc(kk+2)+Imagex(indice)*uincy
               FFloc(kk+3)=FFloc(kk+3)+Imagex(indice)*uincz  
            endif
         enddo
      enddo
!$OMP ENDDO 
!$OMP END PARALLEL       
c     vide les tableaux

      do k=nz-1,2,-1

c     caclul de la polarisation
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)          
         do j=1,ny2
            do i=1,nx2
               ii=i+(j-1)*nx2
               polarisation(ii)=0.d0
            enddo
         enddo
!$OMP ENDDO 
!$OMP END PARALLEL      

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii,jj,l) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2) 
         do j=1,nyl
            do i=1,nxl
               ii=i+(j-1)*nx2
               jj=i+(j-1)*nxl
               if (tabfft(jj).ne.0)  then
                  l=nx*ny*(k-1)+tabfft(jj)
                  polarisation(ii)=(champtx(jj,k)+imagex(jj))
     $                 *polarisa(l,1,1)
               endif
            enddo
         enddo
!$OMP ENDDO 
!$OMP END PARALLEL

#ifdef USE_FFTW
         call dfftw_execute_dft(plan4b,polarisation,polarisation)
#else
         call fftsingletonz2d(polarisation,nx2,ny2,FFTW_BACKWARD)
#endif

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)          
         do j=1,ny2
            do i=1,nx2
               ii=i+(j-1)*nx2
               champ(ii)=polarisation(ii)*FFTTENSOR(ii)
            enddo
         enddo
!$OMP ENDDO 
!$OMP END PARALLEL    

c     fait la FFT inverse pour avoir le champ diffracte
#ifdef USE_FFTW
         call dfftw_execute_dft(plan4f,champ,champ)
#else
         call fftsingletonz2d(champ,nx2,ny2,FFTW_FORWARD)
#endif 

c     calcul propgation champ incident

#ifdef USE_FFTW
         call dfftw_execute_dft(plan2b,Imagex,Imagex)
#else
         call fftsingletonz2d(Imagex,nfft2d,nfft2d,FFTW_BACKWARD)
#endif

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,indice,ii,jj,kx,ky,kz,ctmp)
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2)       
         do j=1,nfft2d
            do i=1,nfft2d
               indice=i+nfft2d*(j-1)
               if (i.gt.nfft2d/2) then
                  ii=i-nfft2d-1
               else
                  ii=i-1
               endif
               if (j.gt.nfft2d/2) then
                  jj=j-nfft2d-1
               else
                  jj=j-1
               endif              
               kx=deltakx*dble(ii)
               ky=deltaky*dble(jj)
               kz=k0*k0-kx*kx-ky*ky
               if (kz.ge.0.d0) then
                  kz=dsqrt(kz)
                  ctmp=cdexp(icomp*kz*aretecube)
                  Imagex(indice)=Imagex(indice)*ctmp
               else
                  Imagex(indice)=0.d0
               endif

            enddo
         enddo
!$OMP ENDDO 
!$OMP END PARALLEL

#ifdef USE_FFTW
         call dfftw_execute_dft(plan2f,Imagex,Imagex)
#else
         call fftsingletonz2d(Imagex,nfft2d,nfft2d,FFTW_FORWARD)
#endif

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(i,j,ii,ll,indice,kk) 
!$OMP DO SCHEDULE(STATIC) COLLAPSE(2) 
         do j=1,nyl
            do i=1,nxl
               indice=i+(j-1)*nxl
               ll=i+(j-1)*nx2
               Imagex(indice)=Imagex(indice)*fac+champ(ll)*fac2
               champtx(indice,k)=Imagex(indice)
               if (tabfft(indice).ne.0)  then                 
                  ii=nx*ny*(k-1)+tabfft(indice)
                  kk=3*(ii-1)
                  FFloc(kk+1)=FFloc(kk+1)+Imagex(indice)*uincx
                  FFloc(kk+2)=FFloc(kk+2)+Imagex(indice)*uincy
                  FFloc(kk+3)=FFloc(kk+3)+Imagex(indice)*uincz               
               endif
c               Imagex(ii)=Imagex(ii)*fac
            enddo
         enddo 
!$OMP ENDDO 
!$OMP END PARALLEL

      enddo
      deallocate(FFTTENSOR)
      deallocate(polarisation)
      deallocate(champ)
      deallocate(champtx)      
      
      end
